const checkLogin = require('letsnet-graphed').check
var gFunctionAuthenticator = require('letsnet-graphed').functionAuth

module.exports = function(defaults) {
    var model = {}

    model.loggedInCheck = function(req, res, next) {
        checkLogin({appid: defaults.gAppID}).check({fingerprint: req.session.fingerprint || '---', logged_user: req.session.logged_user || '---'}, (error, data) => {
            if(!error){
                if(data.document.logged_in){
                    let URL = req.session.redirectURL || '/'
                    delete req.session.redirectURL
                    res.redirect(URL)
                } else next()
            }
            else {
                delete req.session.fingerprint
                delete req.session.logged_user
                next()
            }
        })
    }

    model.loginCheck = function(req, res, next) {
        checkLogin({appid: defaults.gAppID}).check({fingerprint: req.session.fingerprint || '---', logged_user: req.session.logged_user || '---'}, (error, data) => {
            if(error || !data.document.logged_in){
            req.session.redirectURL = req._parsedOriginalUrl.path
            res.redirect('/Login')
            }
            else next()
        })
    }

    model.authenticateFunction = (req, res, next) => {
        gFunctionAuthenticator({appid: defaults.appid}).authenticateFunction({functionID: req.params.function, adminclass: req.headers.authorization.slice(-7)}, function(error, document) {
            console.log(document)
            next()
        })
    }

    return model
}